#include <stdio.h>
#include <string.h>

#define CC (1<<m.lg2)
#define CE (CC+1)
typedef unsigned char uc;
typedef unsigned u;
typedef struct
{
	uc* data;
	u sz;
} data_t;
	
#define DICT_SZ 4096

typedef struct
{
	data_t entries[DICT_SZ];
	u sz;
} lzw_dict_t;

typedef struct
{
	u code;
	u dict_sz;
} code_output_t;

struct
{
	u lg2;
	struct
{
	uc r;
	uc g;
	uc b;
} pal[256];
	u w;
	u h;
	uc data[4194304];
	int il;
}  m;
FILE *f;

#define S(o) fseek(f,o,SEEK_SET)
#define RD(d) fread(&d,4,1,f)
void bmp(const char* n)
{
	int i;
	int row;
	int l;
	int c;
	int idx = 0;
	int data_off;
	f = fopen(n, "rb");
	S(10);
	RD(data_off);
	S(18);
	RD(m.w);
	RD(m.h);
	S(46);
	RD(c);
	if(c == 0)
		c = 256;
	for(i=0; c > (1<<i); ++i);
	m.lg2 = i;
	m.il = m.w==256&&m.h==256;
	l = (m.w + 3) & ~3;
	S(54);

	for(i = 0; i < c; i++)
	{
		m.pal[i].b=fgetc(f);
		m.pal[i].g=fgetc(f);
		m.pal[i].r=fgetc(f);
		fgetc(f);
	}

	row = 0;
	for(i = 0; i < 1+3*m.il; ++i)
	{
		int t[5] = {8,8,4,2};
		int p = m.il?t[i]:1;
		for(; row < m.h; row += p)
		{
			S(data_off + (m.h-row-1) * l);
			fread(&m.data[idx++ * m.w], m.w, 1, f);
		}
		row=t[i+1]/2;
	}
}

#define WB(c) fputc(c,f)
#define WW(c) {short v=c;fwrite(&v,2,1,f);}

lzw_dict_t d;

void add(uc* data, u sz)
{
	data_t*e=&d.entries[d.sz++];
	e->data=data;
	e->sz=sz;
}

uc t[256];
void init_dict()
{
	u i;
	for(i = 0; i < DICT_SZ; i++)
	{
		d.entries[i].data = NULL;
		d.entries[i].sz = 0;
	}
	d.sz = 0;
	for(i = 0; i < CC; i++)
	{
		t[i] = i;
		add(t+i, 1);
	}
	d.sz += 2;
}



data_t w;
u find()
{
	u i;
	for(i = 0; i < d.sz; i++)
	{
		if(w.sz &&
		   w.sz == d.entries[i].sz &&
		   d.entries[i].sz &&
		   memcmp(d.entries[i].data, w.data, w.sz) == 0)
			return i;
	}
	return ~0;
}


int in(uc last)
{
	u i;
	for(i = 0; i < d.sz; i++)
	{
		if(w.sz + 1 == d.entries[i].sz &&
		   memcmp(d.entries[i].data, w.data, w.sz) == 0 &&
		   d.entries[i].data[w.sz] == last)
			return 1;
	}
	return 0;
}


code_output_t codes[8388608];
void lzw()
{
	u i;
	u oi;
	oi = 0;

	
	init_dict();

	codes[oi].code = CC;
	codes[oi].dict_sz = d.sz;
	oi++;
	
	for(i = 0; i < m.w*m.h; i++)
	{
		if(in(m.data[i]))
		{
			if(!w.data) w.data = &m.data[i];
			++w.sz;
		}
		else
		{
			codes[oi].code = find();
			codes[oi].dict_sz = d.sz;
			oi++;
			++w.sz;
			if(d.sz == DICT_SZ)
			{
				codes[oi].code = CC;
				codes[oi].dict_sz = d.sz+1;
				oi++;
				init_dict();
			}
			else
			{
				add(w.data, w.sz);
			}
			w.data = &m.data[i];
			w.sz = 1;
		}
	}
	codes[oi].code = find(&w);
	codes[oi].dict_sz = d.sz;
	oi++;
	codes[oi].code = CE;
	codes[oi].dict_sz = d.sz;
	oi++;
}

uc buf[8388608];
void gif_data()
{
	code_output_t* c;

	uc* p;
	u bc = 0;
	uc sz;
	u i;
	u wc;
	if(m.lg2 <= 1) m.lg2 = 2;

	lzw();

	WB(m.lg2);

	c = codes;
	for(;;)
	{
		u code = c->code;
		u j;
		for(j=0; c->dict_sz > (1<<j) && j < 12; ++j);
		for(i = 0; i < j; i++)
		{
			if(code&1)
				buf[bc>>3] |= 1<<(bc & 7);
			bc++;
			code >>= 1;
		}
		if(c->code == CE)
			break;
		c++;
	} 

	p = buf;
	wc = (bc+7) >> 3;
	while(wc > 0)
	{
		sz=wc>255?255:wc;
		WB(sz);
		fwrite(p, sz, 1, f);
		wc -= sz;
		p += sz;
	}

	WB(0);
}

void gif(const char* n)
{
	int i;
	f = fopen(n, "wb");
	fwrite("GIF89a", 6, 1, f);

	WW(m.w);
	WW(m.h);
	WB((m.lg2-1)|240);
	WB(0);
	WB(0);
	for(i = 0; i < 1<<m.lg2; i++)
	{
		fwrite(&m.pal[i].r, 3, 1, f);
	}

	WB(33);
	WB(249);
	WW(4);
	WW(0);
	WW(0);

	WB(44);
	WW(0);
	WW(0);
	WW(m.w);
	WW(m.h);
	WB(m.il<<6);

	gif_data();
	WB(59);
}

int main(int argc, char** argv)
{
	bmp(argv[1]);
	gif(argv[2]);
	return 0;
}
